var ids={};
var color=["FFFFFF","F0F9FF","dbf0fb","c3e2f3"];
var tag="TR";
var FLASH_OVER=1;
var FLASH_OUT=2;
var FLASH_CHECKED=3;

var FLASH_BUBBLE=false;
var OVER_BUBBLE=false;
var OUT_BUBBLE=false;

var evts={
		"onmouseover": light_on,
		"onmouseout": light_off,
		"onmousedown": light_down
};

function wichIsNotNull(obj1, obj2){return obj1==null?obj2:obj1;}
function isNull(obj){return obj==null;}

function getObject(evt)
{
	this.obj=wichIsNotNull(evt.srcElement, evt.target);
	while(this.obj.tagName!=tag)
	{
		this.obj=this.obj.parentNode;
		if(!isNull(ids[this.obj.gid])&&isNull(this.obj))return null;
	}
	return this.obj;
}

function flashBubbleSet(flash, over, out)
{
	FLASH_BUBBLE=flash;
	OVER_BUBBLE=over;
	OUT_BUBBLE=out;
}

function flashMarkGet(obj){return ids[obj.gid];}
function flashMarked(obj, mark){return flashMarkGet(obj)==mark;}
function flashMarkSet(obj, mark){return ids[obj.gid]=mark;}

function chcol(obj, colorID)
{
	obj.style.backgroundColor='#'+color[colorID];
	return obj;
}

function light_off(evt){
	evt.cancelBubble=true;

	if(OUT_BUBBLE)return false;
	flashBubbleSet(false, false, true);

	this.obj=getObject(evt);

	if(!isNull(this.obj)&&flashMarked(this.obj, FLASH_OVER))
	{
		chcol(this.obj, 0);
		flashMarkSet(this.obj, FLASH_OUT);
	}
	return this.obj;
}

function light_on (evt){
	evt.cancelBubble=true;

	if(OVER_BUBBLE)return false;
	flashBubbleSet(false, true, false);

	this.obj=getObject(evt);

	if(!isNull(this.obj)&&flashMarked(this.obj, FLASH_OUT))
	{
		chcol(this.obj, 1);
		flashMarkSet(this.obj, FLASH_OVER);
	}
	return this.obj;
}

function light_down(evt){
	evt.cancelBubble=true;

	if(evt.button>1||FLASH_BUBBLE)return false;
	flashBubbleSet(true, false, false);

	this.obj=getObject(evt);

	if(isNull(this.obj))return null;

	if(flashMarked(this.obj, FLASH_CHECKED))
	{
		chcol(this.obj, 3);
		flashMarkSet(this.obj, FLASH_OVER);
	}
	else
	{
		chcol(this.obj, 2);
		flashMarkSet(this.obj, FLASH_CHECKED);
	}

	return this.obj;
}

function loadFlashLines(objs)
{
	if(isNull(document.attachEvent))
	{
		this.func="addEventListener";
		this.substr=2;
	}
	else
	{
		this.func="attachEvent";
		this.substr=0;
	}

	for(this.i=0; this.i<objs.length; this.i++)
	{
		this.obj=document.getElementById(objs[this.i]);
		if(isNull(this.obj))continue;

		this.all=this.obj.getElementsByTagName(tag);
		if(isNull(this.all))continue;

		for(this.z=0; this.z<this.all.length; this.z++)
			if(this.all[this.z].parentNode.tagName=="TBODY")
			{
				this.id=objs[this.i]+'_'+this.z;

				this.all[this.z]["id"]=this.id;
				this.all[this.z]["gid"]=this.id;

				ids[this.id]=FLASH_OUT;

				for(this.q in evts)
					this.all[this.z][this.func](this.q.substr(this.substr), evts[this.q], false);
			}
	}
}


	var sortIndex=0;
	var sortIdx=0;
	var sortType=[[1, -1, 0], [-1, 1, 0]];
	var sortVar="inner"+["Text", "HTML"][isNull(document.attachEvent)?1:0];
	var objects={};

	function sortGroupFromTableFunction(a, b)
	{
		if(a[sortIndex][sortVar]>b[sortIndex][sortVar])return sortType[sortIdx][0];
		if(a[sortIndex][sortVar]<b[sortIndex][sortVar])return sortType[sortIdx][1];
		return sortType[sortIdx][2];
	}

	function sortMatrixFromTable(obj)
	{
		for(this.i in obj)
			obj[this.i].sort(sortGroupFromTableFunction);

		return obj;
	}

	function createMatrixFromTable(obj)
	{
		this.res=[];
		obj.normalize();
		this.groups=obj.getElementsByTagName("TBODY");
		for(this.i=0; this.i<this.groups.length; this.i++)
		{
			this.group=this.groups[this.i];
			this.cgroup=[];

			this.rows=this.group.getElementsByTagName("TR");

			for(this.q=0; this.q<this.rows.length; this.q++)
			{
				this.row=this.rows[this.q];
				this.crow=[];
				this.cells=this.row.getElementsByTagName("TD");
				for(this.z=0; this.z<this.cells.length; this.z++)
				{
					this.clone=this.cells[this.z].cloneNode(true);
					this.clone["parent"]=this.cells[this.z].parentNode;
					this.crow.push(this.clone);
				}
				this.cgroup.push(this.crow);
			}

			this.res.push(this.cgroup);
		}
		return this.res;
	}

	function showTableRows(obj, table)
	{
		this.groups=table.getElementsByTagName("TBODY");
		for(this.i=0; this.i<obj.length; this.i++)
		{
			this.group=this.groups[this.i];
			this.rows=this.group.getElementsByTagName("TR");
			for(this.q in obj[this.i])
			{
				this.cells=this.rows[this.q].getElementsByTagName("TD");
				this.bool=true;
				for(this.z in obj[this.i][this.q])
				{
					this.cell=obj[this.i][this.q][this.z];
					if(this.bool)
					{
						flashMarkSet(this.cell.parent, FLASH_OUT);
						chcol(this.cell.parent, 0);
						OUT_BUBBLE=true;
					}
					this.cells[this.z].innerHTML=this.cell.innerHTML;
				}
			}
		}
		return false;
	}

	function sortTableRows(evt)
	{
		evt.cancelBubble=true;
		this.obj=wichIsNotNull(evt.srcElement, evt.target);

		while(!isNull(this.obj)&&this.obj.tagName!="TH")
			this.obj=this.obj.parentNode;

		if(this.obj==null)return false;

		this.table=document.getElementById(this.obj.getAttribute("tid"));
		if(isNull(this.table))return null;
		this.matrix=createMatrixFromTable(this.table);

		sortIndex=this.obj.getAttribute("tcol");
		sortIdx=parseInt(this.obj.getAttribute("state"));
		this.obj.setAttribute("state", sortIdx?0:1);

		return showTableRows(sortMatrixFromTable(this.matrix), this.table);
	}

	function markAllTables(ids)
	{
		if(isNull(document.attachEvent))
		{
			this.func="addEventListener";
			this.substr=2;
		}
		else
		{
			this.func="attachEvent";
			this.substr=0;
		}

		for(this.i=0; this.i<ids.length; this.i++)
		{
			this.id=ids[this.i];
			objects[this.id]=document.getElementById(this.id);
			this.groups=objects[this.id].getElementsByTagName("THEAD");

			for(this.q=0; this.q<this.groups.length; this.q++)
			{
				this.group=this.groups[this.q];
				if(!isNull(this.group))
					for(this.z=0, this.rows=this.group.getElementsByTagName("TR");
						this.z<this.rows.length; this.z++)
					{
						this.row=this.rows[this.z];
						this.cells=this.row.getElementsByTagName("TH");
						this.len=this.cells.length;

						for(this.o=0; this.o<this.len; this.o++)
						{
							try
							{
								this.cell=this.cells[this.o];

								this.link=document.createElement("A");
								this.link.innerHTML=this.cell.innerHTML;
								this.cell.innerHTML="";

								this.link.href="javascript: //  ";
								this.link[this.func](
									"onclick".substr(this.substr), sortTableRows, false);

								this.cell.appendChild(this.link);
								this._tid_=document.createAttribute("tid");
								this._tcol_=document.createAttribute("tcol");
								this._state_=document.createAttribute("state");
								this.cell.setAttributeNode(this._tid_);
								this.cell.setAttributeNode(this._tcol_);
								this.cell.setAttributeNode(this._state_);
								this._tid_.value=this.id;
								this._tcol_.value=this.o;
								this._state_.value=1;
							}catch(error){continue}
						}
					}
			}
		}
	}